package com.iona.camel.samples;

import org.apache.camel.Endpoint;
import org.apache.camel.EndpointInject;
import org.apache.camel.Exchange;
import org.apache.camel.PollingConsumer;
import org.apache.camel.Producer;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ExchangePoller{

	@EndpointInject(uri="activemq:queue:POLLING.CONSUMER")
	private Endpoint sourceEndpoint;
	
	@EndpointInject(uri="direct:fromPoller")
	private Endpoint targetEndpoint;

	private static final Log LOG = LogFactory.getLog(ExchangePoller.class);
	
	public void start(){
		new Thread(
			new Runnable(){
				public void run() {
					try {
						LOG.info("Starting JMS poller");
						Thread.sleep(5000);
						long timeout = 1000;
						PollingConsumer consumer;
						
						consumer = sourceEndpoint.createPollingConsumer();
						
						Producer producer = targetEndpoint.createProducer();
	
						while(true){
							Exchange exchange = consumer.receive(timeout);
							
							while(exchange != null){
								LOG.info("Received message: " + exchange.getIn().getBody());
								
								Exchange newExchange = producer.createExchange(exchange);
								newExchange.getIn().setBody(exchange.getIn().getBody());
								newExchange.getIn().setHeaders(exchange.getIn().getHeaders());
								producer.process(newExchange);
								
								exchange = consumer.receive(timeout);
							}
							
							Thread.sleep(10000);
						}
					} catch (Exception e) {
						throw new RuntimeException(e);
					}
				}
				
		}).start();
	}
}
