package com.iona.camel.samples;

import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.spring.Main;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class SampleRouter extends RouteBuilder {

	private static int count = 0;
	private static final Log LOG = LogFactory.getLog(SampleRouter.class);

	@SuppressWarnings("unchecked")
	@Override
	public void configure() throws Exception {
		
		from("timer://timerObj?fixedRate=true&delay=0&period=3000")
			.process(new Processor(){
			public void process(Exchange exchange) throws Exception {
				count ++;
				String out = "Message " + count;
				LOG.info("SENDING: " + out);
				exchange.getOut().setBody(out);
			}})
			.to("activemq:POLLING.CONSUMER");
		
		from("direct:fromPoller")
			.to("log:logggerFromPoller");
	}
	
    public static void main(String... args){
    	Main.main(args);
    }
}




